// Con Clase Agosto 2023
// Ejemplo de generacin de cdigo QR por segmentos
// Salvador Pozo
// Nota: si en la consola se usa el texto blanco sobre fondo negro
// el cdigo estar invertido y el cdigo no ser lejible.
// Se puede corregir esto de varios modos:
// - Intercambiar los espacios y los dots (aunque habra que aadir
//   dots extras alrededor del cdigo.
// - Modificar los colores asignados a las propiedades de la consola.
// - La ms sencilla, seleccionar el texto de la consola, que invierte
//   los colores.

#include <iostream>
#include <cstring>
#include "qrcodegen.h"

using namespace std;

int main() {
    const char *cad1 = "TEXTO MEZCLADO CON NUMEROS:";
    const char *cad2 = "123546789";
    uint8_t qrcode[qrcodegen_BUFFER_LEN_MAX];
    uint8_t tempBuffer[qrcodegen_BUFFER_LEN_MAX];

    uint8_t *segBuff1 = new uint8_t[qrcodegen_calcSegmentBufferSize(qrcodegen_Mode_ALPHANUMERIC, strlen(cad1)) * sizeof(uint8_t)];
    uint8_t *segBuff2 = new uint8_t[qrcodegen_calcSegmentBufferSize(qrcodegen_Mode_NUMERIC, strlen(cad2)) * sizeof(uint8_t)];

    if(segBuff1 == NULL || segBuff2 == NULL) {
        cout << "Error" << endl;
        delete[] segBuff1;
        delete[] segBuff2;
        return 1;
    }
	struct qrcodegen_Segment segs[] = {
		qrcodegen_makeAlphanumeric(cad1, segBuff1),
		qrcodegen_makeNumeric(cad2, segBuff2),
	};

    bool ok = qrcodegen_encodeSegments(segs, sizeof(segs) / sizeof(segs[0]), qrcodegen_Ecc_LOW, tempBuffer, qrcode);

    if (!ok) return 1;

    int size = qrcodegen_getSize(qrcode);
    for (int y = 0; y < size; y++) {
        for (int x = 0; x < size; x++) {
            if(qrcodegen_getModule(qrcode, x, y)) {
                cout << (char)219 << (char)219;
            } else {
                cout << "  ";
            }
        }
        cout << endl;
    }

    delete[] segBuff1;
    delete[] segBuff2;

    return 0;
}
